CDISCLAIMER
C ***********************************************************************
C BECAUSE  EXSAS  IS FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM,
C TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED
C IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM
C "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
C INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
C AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY
C AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE
C DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
C CORRECTION.
C 
C IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
C WILL  MPE  BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
C INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY
C TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
C BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES
C OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN
C IT HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
C 
C Garching, 27 April 1998
C ***********************************************************************
CDISCLAIMER-END
C @(#)dradrs.for	1.1 (MPE-Garching) 3/16/94 16:27:36
      FUNCTION DRADRS(DRAD)
C
CC    'Resets' radians to the interval  0 .. 2 * pi
C
C************************ FFORM VERSION 1.2 ************ 30-MAR-90 16:58
C
CA  author : KOD        date: 19-JUL-1989 18:31
CU  update : KOD        date: 29-MAR-1990 15:08
CU  update : EXSAS              date: 03-AUG-1993 15:47
C
CT  status: tested
C
C   general description 
CG  'Resets' radians to the interval  0  .. 2 * pi.
C
C   call_var.          type I/O description 
CP  DRAD                R8  I   radians (may be negative)
CP  DRADRS              R8      radians inside the interval  0 .. 2 * pi
C
C   include_block name          description 
CI  RCOMMON:CGENL.CMN          general parameter common block
CI  RCOMMON:IGENL.INC         parameter block with trig. constants
C
C   routines_called    type     description 
CR  RESVAL              SR      'resets' periodic variables
CR  ERRSTC              SR      continue error stack for one level
CR  HFLAG               R4      output flag handling routine
CR  WRFLAG              SR      writes to FLAG output stream
C
C   extensions/system calls     description 
CX                              
C
C***********************************************************************
C
C   variables   meaning
C
C
      IMPLICIT NONE
      INCLUDE 'RCOMMON:CGENL.CMN'
      INCLUDE 'RCOMMON:IGENL.INC'
C
      DOUBLE PRECISION
     &        DRAD, DXMIN, DXMAX, DXOLD, DXNEW
      DOUBLE PRECISION
     &        DRADRS
      REAL        HFLAG
      INTEGER     IERR ,IOS, ISTAT
      CHARACTER*8   RTNAME
C
      SAVE
      DATA          RTNAME /'DRADRS'/
C
      IERR = 0
C
      DXMIN = 0.D0
      DXMAX = D2PI
      DXOLD = DRAD
C
      CALL RESVAL(DXMIN,DXMAX,DXOLD,DXNEW,ISTAT)
C
      if (ISTAT.gt.1) then
        IERR = max(IERR,ISTAT)
        call ERRSTC(RTNAME,10)
      endif
C
      if (IERR.lt.2) DRADRS = DXNEW
C
C
      RETURN
      END
